//app.js
App({
  onLaunch: function () {
    // 展示本地存储能力
    //var logs = wx.getStorageSync('logs') || []
    //logs.unshift(Date.now())
    //wx.setStorageSync('logs', logs)

    var baidu_token = wx.getStorageSync('baidu_token') || {}
    if (baidu_token) {
      if (baidu_token.time - Date.now() <= 300000) {
        this.sysBaiduOpenApiToken();
      }
    }

    var _this = this;
    setTimeout(function () {
      console.log('baidu_token start ........')
      wx.setStorageSync('baidu_token', baidu_token)
      _this.sysBaiduOpenApiToken();
    }, 5)
    var userId = wx.getStorageSync('userId') || ''
    console.log(userId);
    if(!userId){
      // 登录
      wx.login({
        success: res => {
          // 发送 res.code 到后台换取 openId, sessionKey, unionId
          console.log(res.code);
          wx.request({
            url: _this.server + 'SmallProgram/WechatSight/getUserInfo',
            data: {
              code: res.code
            },
            success: function (event) {
              console.log(event.data)
              //用户信息已经存在
              if (event.data.code == '10000') {
                //var pid = wx.getStorageSync('pid') || ''
                var userId = event.data.data.userId
                wx.setStorageSync('userId', userId)
              } else if (event.data.code == '20000') {

              } else {
                console.log("接口用户信息获取失败")
              }
            }
          })
        }
      })
    }
     
  },
  /*getUserInfo: function (cb) {
    var that = this
    if (this.globalData.userInfo) {
      typeof cb == "function" && cb(this.globalData.userInfo)
    } else {
      //调用登录接口
      wx.login({
        success: function () {
          wx.getUserInfo({
            success: function (res) {
              that.globalData.userInfo = res.userInfo
              typeof cb == "function" && cb(that.globalData.userInfo)
            }
          })
        }
      })
    }
  },*/    
  globalData: {
    userInfo: null
  },
  sysBaiduOpenApiToken: function () {

    var currentTimeIn = Date.now();
    var baidu_token = wx.getStorageSync('baidu_token') || {}
    if (baidu_token.time) {
      if (baidu_token.time - Date.now() <= 300000) {
        console.log("baidu_token request ...")
        this.getBaiduOpenApiToken(function (baidu_token) {
          console.log(baidu_token);
          baidu_token.time = Date.now() + 7200000
          wx.setStorageSync('baidu_token', baidu_token)
        });
      } else {
        console.log("baidu_token have ...")
      }
    }else{
      console.log("else baidu_token request ...")
      this.getBaiduOpenApiToken(function (baidu_token) {
        //console.log(baidu_token);
        baidu_token.time = Date.now() + 7200000
        wx.setStorageSync('baidu_token', baidu_token)
      });
    }
  },
  getBaiduOpenApiToken: function (cb) {
    console.log('getBaiduOpenApiToken');
    var url = 'https://openapi.baidu.com/oauth/2.0/token';
    wx.request({
      url: url,
      data: {
        grant_type: 'client_credentials', 
        client_id: 'lagZdrinq7W8AAec6NDmcq18BSPC7ZUg', 
        client_secret: 'eY2vLcfI5yu1YhGnxwlimu7kojLLtGVz'
      },
      header: {
        'Content-Type': 'application/json'
      },
      success: function (res) {
        //console.log(res)
        typeof cb == "function" && cb(res.data);
      }, fail: function (e) {
        console.log(e);
      }
    })
  },
  server: 'https://seex.dev.iouou.cn/',
})